#!/usr/bin/env python3
"""
GISAS of cosine-profile ripples on a 2D paracrystal lattice.

CosineRippleBox particles (100 × 20 × 4 nm) are arranged on a
rectangular paracrystal with 20 nm × 100 nm unit cell (90° angle).
The peaks are oriented along Y (lattice vector B = 100 nm).
"""
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm
import math


def get_sample():
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("Particle", particle_color, 6e-4, 2e-8)
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 6e-6, 2e-8)
    vacuum = ba.Vacuum()

    length_ripple = 100 * nm
    ff = ba.CosineRippleBox(length_ripple, 20 * nm, 4 * nm)
    particle = ba.Particle(particle_mat, ff)

    profile = ba.Profile2DGauss(150 * nm, 600 * nm, 0)
    lattice = ba.BasicLattice2D(20 * nm, length_ripple, math.pi / 2, 0)
    structure = ba.Paracrystal2D(particle, lattice, 1000 * nm, 1e4 * nm, 1e4 * nm)
    structure.setProbabilityDistributions(profile, profile)

    vacuum_layer = ba.Layer(vacuum)
    substrate_layer = ba.Layer(substrate_mat)
    vacuum_layer.deposit2D(structure)

    sample = ba.Sample()
    sample.addLayer(vacuum_layer)
    sample.addLayer(substrate_layer)
    return sample


<%= include_partial("template/sim/gisas_standard_wide.py") -%>


<%= include_partial("template/main/runsim_unitaspect.py",
    "ba.showSample3D(sample, sample_size=1000*nm, seed=0)") -%>
